<?php

include_once( ABSPATH . '/wp-admin/includes/admin.php' );


global $wpdb;

$BudgetDropDownTableName = $wpdb->prefix . 'BudgetDropDownTable';


if(isset($_POST["CreateBudget"]))
{
    BudgetDropDownNewBudgetSQL();
}


function BudgetDropDownNewBudget() {
    
    global $BudgetDropDownTableName;
    
    if (!current_user_can('manage_options'))  {
        wp_die( __('You do not haver permissions to see this page.') );
    }
    
    if (empty($_POST[IDBudget]))
    {
    
       $IDBudget = rand(0, 65535);
       $BudgetTitle = '';
       $HighBudgetCode = '';
       $IntermediateBudgetCode = '';
       $LowBudgetCode = '';
       $UpdateBudget = 'false';       
    
    } else {
        
        $IDBudget = $_POST['IDBudget'];
        $UpdateBudget = 'true';
        
        global $BudgetDropDownTableName;
        global $wpdb;
        $query = $wpdb->get_results( "select BudgetTitle, HighBudgetCode, IntermediateBudgetCode, LowBudgetCode from $BudgetDropDownTableName where IDBudget='$IDBudget'");
        foreach ($query as $field) {
            $BudgetTitle = $field->BudgetTitle;
            $HighBudgetCode = $field->HighBudgetCode;
            $IntermediateBudgetCode = $field->IntermediateBudgetCode;
            $LowBudgetCode = $field->LowBudgetCode;
        }
    }
    
    $BudgetTitle = str_replace("'", "&rsquo;", $BudgetTitle);
    $HighBudgetCode = str_replace("'", "&rsquo;", $HighBudgetCode);
    $IntermediateBudgetCode = str_replace("'", "&rsquo;", $IntermediateBudgetCode);
    $LowBudgetCode = str_replace("'", "&rsquo;", $LowBudgetCode);
    
    $BudgetTitle = str_replace('"', '&quot;', $BudgetTitle);
    $HighBudgetCode = str_replace('"', '&quot;', $HighBudgetCode);
    $IntermediateBudgetCode = str_replace('"', '&quot;', $IntermediateBudgetCode);
    $LowBudgetCode = str_replace('"', '&quot;', $LowBudgetCode);
    
    echo "Budget title:<br>";
    
    echo "<form method='post' action='#'>";
    
    echo "<input type='text' id='BudgetTile' name='BudgetTitle' size='50' value='$BudgetTitle'><br>";
    echo "Low budget HTML or Shortcode here:<br>";
    echo "<input type='text' id='LowBudgetCode' name='LowBudgetCode' size='50'  value='$LowBudgetCode'></text><br>";
    echo "Intermediate budget HTML or Shortcode here:<br>";
    echo "<input type='text' id='IntermediateBudgetCode' name='IntermediateBudgetCode' size='50'  value='$IntermediateBudgetCode'></text><br>";
    echo "High budget HTML or Shortcode here:<br>";
    echo "<input type='text' id='HighBudgetCode' name='HighBudgetCode' size='50'  value='$HighBudgetCode'></text><br>";
    echo "<input id='IDBudget' name='IDBudget' type='hidden' value='$IDBudget'>";
    echo "<input id='UpdateBudget' name='UpdateBudget' type='hidden' value='$UpdateBudget'>";
    echo "<input type='submit' value='Create or Update Budget' name='CreateBudget' id='CreateBudget'>";
    
    echo "</form>";
    
    if ( $_POST['CreateBudget'] ) {
        echo "Budget updated or created";
    }
    
}

function BudgetDropDownNewBudgetSQL() {
    
    global $BudgetDropDownTableName;
        
    $BudgetTitle = $_POST['BudgetTitle'];
    $HighBudgetCode = $_POST['HighBudgetCode'];
    $IntermediateBudgetCode = $_POST['IntermediateBudgetCode'];
    $LowBudgetCode = $_POST['LowBudgetCode'];
    $IDBudget = $_POST['IDBudget'];
    $UpdateBudget = $_POST['UpdateBudget'];
    
    $BudgetTitle = str_replace("'", "\'", $BudgetTitle);
    $HighBudgetCode = str_replace("'", "\'", $HighBudgetCode);
    $IntermediateBudgetCode = str_replace("'", "\'", $IntermediateBudgetCode);
    $LowBudgetCode = str_replace("'", "\'", $LowBudgetCode);
    
    $BudgetTitle = str_replace('"', '\"', $BudgetTitle);
    $HighBudgetCode = str_replace('"', '\"', $HighBudgetCode);
    $IntermediateBudgetCode = str_replace('"', '\"', $IntermediateBudgetCode);
    $LowBudgetCode = str_replace('"', '\"', $LowBudgetCode);
     
    
    if ( $UpdateBudget == 'false' ) {
    
       $sql = "INSERT INTO $BudgetDropDownTableName ( IDBudget, BudgetTitle, HighBudgetCode, IntermediateBudgetCode, LowBudgetCode ) VALUES ('$IDBudget', '$BudgetTitle', '$HighBudgetCode', '$IntermediateBudgetCode', '$LowBudgetCode' );";
    } elseif ( $UpdateBudget == 'true') {
        
       $sql = "UPDATE $BudgetDropDownTableName set BudgetTitle = '$BudgetTitle', HighBudgetCode = '$HighBudgetCode' , IntermediateBudgetCode = '$IntermediateBudgetCode', LowBudgetCode = '$LowBudgetCode' where IDBudget='$IDBudget';";
        
    }
    
    dbDelta( $sql );
    
}

function BudgetDropDownDisplayShortcode( $atts ) {
    
    // begin output buffering
    ob_start();
    
    $id = $atts['id'];
    global $BudgetDropDownTableName;
    $SelectionName = "BudgetDropDownBusgetSelection$id";
    
    if ( empty ($_POST[$SelectionName]) ) {
        $BudgetSelection = 'High';
        $HighSelected='';
        $IntermediateSelected='';
        $LowSelected='';
    }
    else {
        $BudgetSelection = $_POST[$SelectionName];
    }
    
    switch ( $BudgetSelection ) {
        
        case 'High':
            $HighSelected='selected';
            break;
        case 'Intermediate':
            $IntermediateSelected='selected';
            break;
        case 'Low':
            $LowSelected='selected';
            break;
    } 
    
    echo '<form method="post" action="#">';
    echo "<select name='BudgetDropDownBusgetSelection$id' id='BudgetDropDownBusgetSelection$id'>";
    echo "<option value='High' $HighSelected>High</option>";
    echo "<option value='Intermediate' $IntermediateSelected>Intermediate</option>";
    echo "<option value='Low' $LowSelected>Low</option>";  			
    echo '</select>';
    echo "<input type='submit' value='Budget Selection' name='BudgetSelection' id='BudgetSelection'>";
    echo '</form>';
        
    global $wpdb;
    $query = $wpdb->get_results( "select HighBudgetCode, IntermediateBudgetCode, LowBudgetCode from $BudgetDropDownTableName where IDBudget='$id'");
            
    foreach ($query as $field) {        
        $HighBudgetCode = $field->HighBudgetCode;
        $IntermediateBudgetCode = $field->IntermediateBudgetCode;
        $LowBudgetCode = $field->LowBudgetCode;        
    }
            
    switch ( $BudgetSelection ) {
        
        case 'High':
            echo do_shortcode($HighBudgetCode);
            break;
        case 'Intermediate':
            echo do_shortcode($IntermediateBudgetCode);            
            break;
        case 'Low':
            echo do_shortcode($LowBudgetCode);
            break;           
    }    
    
    return ob_get_clean();
    
}

add_shortcode('BudgetDropDown', 'BudgetDropDownDisplayShortcode');


function BudgetDropDownListBudget() {
        
    global $wpdb;
    global $BudgetDropDownTableName;
    
    if ( $_POST['RemoveDropDownBudget'] ) {
        $IDBudget = $_POST['IDBudget'];
        $wpdb->delete( $BudgetDropDownTableName, array( 'IDBudget' => $IDBudget ) );
        
    }
        
    $query = $wpdb->get_results( "select IDBudget, BudgetTitle from $BudgetDropDownTableName");
    
    foreach ($query as $field) {
        $IDBudget = $field->IDBudget;
        $BudgetTitle = $field->BudgetTitle;
        $EditAction = get_home_url() . '/wp-admin/admin.php?page=New_Budget_submenu';
                
        echo "<form method='post' action='$EditAction'>";
        echo "$BudgetTitle<br>";
        echo "<input id='IDBudget' name='IDBudget' type='hidden' value='$IDBudget'>";
        echo "<input type='submit' value='Edit' name='EditBudget' id='EditBudget'>";
        echo "</form>";
        
        echo "<form method='post' action=''>";
        echo "<input id='IDBudget' name='IDBudget' type='hidden' value='$IDBudget'>";
        echo "<input type='submit' value='Remove' name='RemoveDropDownBudget' id='RemoveDropDownBudget'>";
        echo "</form>";
        
    }    

}

?>