<?php
/*
Plugin Name: BudgetDropDown
Version: 1.0
Description: This plugin show one dropdown list for a products with a high, medium o lowcost budget
Author: David Martínez Perales
License: GPL2
*/

include_once( ABSPATH . '/wp-admin/includes/upgrade.php' );
include_once( ABSPATH . 'wp-content/plugins/BudgetDropDown/CreateModifyBudget.php' );

add_action('admin_menu', 'menu_BudgetDropDown');
function menu_BudgetDropDown() {
   
    add_menu_page('Menu_BudgetDropDown',
        'BudgetDropDown',
        'mainBudgetDropDown',
        'Menu_BudgetDropDpwn',
        'BudgetDropDownNewBudget','',3);
    
    add_submenu_page ( 'Menu_BudgetDropDpwn',
        'List Budgets',
        'List Budgets',
        'manage_options',
        'List_Budgets_submenu',
        'BudgetDropDownListBudget' );
    
    add_submenu_page ( 'Menu_BudgetDropDpwn',
        'New Budget',
        'New Budget',
        'manage_options',
        'New_Budget_submenu',
        'BudgetDropDownNewBudget' );
    
}


function BudgetDropDownActivation()
{
    
    // Create BudgetDropDown Table
    
    global $wpdb;
    
    $charset_collate = $wpdb->get_charset_collate();
    $BudgetDropDownTableName = $wpdb->prefix . 'BudgetDropDownTable'; 
    
    $sql = "CREATE TABLE IF NOT EXISTS $BudgetDropDownTableName (
        IDBudget INT PRIMARY KEY,
        BudgetTitle VARCHAR(50) NOT NULL,
        HighBudgetCode TEXT NOT NULL,
        IntermediateBudgetCode TEXT NOT NULL,
        LowBudgetCode TEXT NOT NULL ) $charset_collate;";
    
    require_once( ABSPATH . 'wp-admin/includes/upgrade.php' );
    dbDelta( $sql );
        
}
register_activation_hook(__FILE__,'BudgetDropDownActivation');


?>